#include "fortune.h"

void prn_info(cchr* pgm_name)
{
   cout << "---\n"
           "Usage:  " << pgm_name << " [-h[h[h]]] [-t]\n"
           "\n"
           "---\n"
           "Options:\n"
           "   -h     help option, print this message\n"
           "   -hh    help help option, print more information\n"
           "   -hhh   help help help option, some historical remarks\n"
           "             and two example fortunes get printed\n"
           "   -t     test option, print information for the programmer\n"
           "\n";
}

void prn_more_info(cchr* pgm_name)
{
   prn_info(pgm_name);

   cout << "\n"
           "---\n"
           "Some UNIX machines provide a command that will get you a\n"
           "randomly selected fortune from the fortune database.  Try\n"
           "the following command:\n"
           "\n"
           "   fortune\n"
           "\n"
           "If this fails, you can try something like\n"
           "\n"
           "   /usr/games/fortune\n"
           "\n"
           "You can also look for the fortune command in the online manual;\n"
           "try the command\n"
           "\n"
           "   man fortune\n"
           "\n"
           "If this fails, you should give up, but before you do, you may\n"
           "find it instructive to give the command\n"
           "\n"
           "   find_fortune -hhh\n"
           "\n"
           "This will provide you with some historical information, along\n"
           "with two example fortunes.\n"
           "\n"
           "---\n"
           "The rest of this discussion is predicated on the assumption\n"
           "that the fortune command works on your machine.\n"
           "\n"
           "Sometimes an interesting fortune gets printed.  If so, how can\n"
           "it be captured?  Well, with the graphical user interfaces that\n"
           "are prevalent today, it is easy to cut and paste from one window\n"
           "to another.  However, when this program was first written, all\n"
           "that most people had on their desktops were dumb terminals.\n"
           "With that kind of equipment, how do you capture an interesting\n"
           "fortune? If you give the fortune command again, you get a new\n"
           "fortune, not the one you just saw and wanted to capture.  On\n"
           "most UNIX systems, all the fortunes are contained in the file\n"
           "\n"
           "   /usr/games/fortune/fortunes.dat\n"
           "\n"
           "This file, however, is unreadable to the public.  Our program\n"
           "looks at randomly generated fortunes repeatedly, and when it\n"
           "finds one that contains the phrase the user is looking for,\n"
           "the fortune gets saved in a file and e-mail gets sent to\n"
           "alert the user that one or more fortunes were saved.\n"
           "\n"
           "---\n"
           "The modern graphical user interface makes it easy to capture a\n"
           "fortune that just got printed.  But what if you want to find\n"
           "one or more fortunes that contain a given phrase, such as\n"
           "\"Miss Manners\"?  This program will find them for you.\n"
           "\n";
}

void prn_much_more_info()
{
   cout << "\n"
           "---\n"
           "FIND A FORTUNE\n"
           "\n"
           "In the 1980s, when Berkeley UNIX was prevalent, the fortune command\n"
           "could be found on most, but not all, UNIX systems.  Today, Berkeley\n"
           "UNIX is much less prevalent than it was, and probably less than half\n"
           "of the UNIX systems offer the fortune command.  If you are on a UNIX\n"
           "system, try the following commands:\n"
           "\n"
           "   man fortune       // to read about the command\n"
           "\n"
           "   fortune           // to get a fortune\n"
           "\n"
           "If the fortune command does not run on your machine, this program\n"
           "will not work properly.\n"
           "\n"
           "The fortune command gets a fortune from its database in a random\n"
           "fashion and prints it on the screen.  Some fortunes are short and\n"
           "pity, others are longer and may contain an historical or\n"
           "philosophical message.  Here are two example:\n"
           "\n"
           "   ---\n"
           "   First fortune:\n"
           "\n"
           "   f u cn rd ths, u cn gt a gd jb n cmptr prgrmmng.\n"
           "   \n"
           "   ---\n"
           "   Second fortune:\n"
           "\n"
           "      One of the questions that comes up all the time is: How\n"
           "   enthusiastic is our support for UNIX?\n"
           "      Unix was written on our machines and for our machines\n"
           "   many years ago.  Today, much of UNIX being done is done on\n"
           "   our machines.  Ten percent of our VAXs are going for UNIX\n"
           "   use.  UNIX is a simple language, easy to understand, easy to\n"
           "   get started with.  It's great for students, great for somewhat\n"
           "   casual users, and it's great for interchanging programs between\n"
           "   different machines.  And so, because of its popularity in these\n"
           "   markets, we support it.  We have good UNIX on VAX and good UNIX\n"
           "   on PDP-11s.\n"
           "      It is our belief, however, that serious professional users\n"
           "   will run out of things they can do with UNIX. They'll want a\n"
           "   real system and will end up doing VMS when they get to be serious\n"
           "   about programming.\n"
           "      With UNIX, if you're looking for something, you can easily and\n"
           "   quickly check that small manual and find out that it's not there.\n"
           "   With VMS, no matter what you look for -- it's literally a five-\n"
           "   foot shelf of documentation -- if you look long enough it's there.\n"
           "   That's the difference -- the beauty of UNIX is it's simple; and\n"
           "   the beauty of VMS is that it's all there.\n"
           "\n"
           "      -- Ken Olsen, President of DEC, 1984\n"
           "\n"
           "\n"
           "---\n"
           "Suppose you want to see if you can find other fortunes that mention\n"
           "Ken Olsen, or you want to look for fortunes with, say, the phrase\n"
           "\n"
           "   I love you\n"
           "\n"
           "in them.  You can give the fortune command repeatedly, but most\n"
           "likely you will not see anything relevant.  The fortunes are pulled\n"
           "in a random fashion from a rather large, inaccessible database, and\n"
           "there is little chance of seeing a fortune that contains a desired\n"
           "phrase.\n"
           "\n"
           "---\n"
           "This program finds fortunes that may be of interest to you.  The\n"
           "program prompts the user for a phrase, and then runs the fortune\n"
           "program repeatedly, looking for a match with the phrase.  If a\n"
           "match is found, the fortune is saved to a file and e-mail is sent\n"
           "to alert the user that one or more fortunes were saved.\n"
           "\n"
           "The reason for using e-mail is that the program may run for 20\n"
           "minutes or more.  You can put the program in background and forget\n"
           "about it.  You will be notified later about the results of your\n"
           "search.\n"
           "\n";
}
